#!/usr/bin/env python

#           [option, long option,                    variable,            action,        data,     default,                            metavar,    description]
"""arizonaconfig
   options=[   
            ["",   "--managerconf",                 "managerconf",        "store",       "string", "~/.storkmanager.conf",                  "FILE",      "use a different config file (~/.storkmanager.conf is the default)"]
   ]
   includes=[]        
"""


from Tkinter import *
from tkMessageBox import *
from Tkinter import _setit
import tkFileDialog
import tkFont
import os
import sys
import re
import webbrowser

import storkcurlfuncs as sc
import arizonaconfig
import storkpackage
import storkutil



#the version of the gui, this number should be incremented
#whenever there is a change to this file, or a change to 
guiversion = "$Revision: 1.21 $"

checkedforupdate = False

debug = False

groupframes = {} 
groups = []
nodes  = {} #a dict of groupname->array of nodes          
actions= {}
to_upload=[]

next_group_row = 0
switch_user = False

# whether the current state is in synch with the repository
synched = True

root = None

topoptions = None
username = None
password = None
storkusername = "jplichta"
if not debug: storkusername = None

# Flags that will always be passed to storkutil to identify this user. 
# This gets set later, don't add extra flags to this here.
storkutiluserflags = None

# The directory the script is located in.
scriptpath = os.path.realpath(os.path.dirname(sys.argv[0]))

# Path to images used by the GUI.
imagepath = os.path.join(scriptpath, "images")

# Path to where all non-temp files that are read and created.
# Note: not fully implemented yet. Leave empty to have it be ignored.
# The idea would be to make setting/changing the working directory
# available through the GUI, but this works for testing.
# Example:
#workingpath = "/home/myusername/somedirectory";
workingpath = ""
commandstub = ""

# Change working directory so files are read from and created there.
# This would be done somewhere else once one can set this from the GUI.
if workingpath:
    print "Changing working directory to: "+workingpath
    os.chdir(workingpath)


# Change the commands for different OS
#HOME is for Linux. Command should be '../storkutil.py' For windows, 
#it is simply 'storkutil.py'
if 'HOME' in os.environ:
    commandstub = '/'



def isPackage(path):
   # lets try not to tar or rpm in case they are on windows,
   # so we will do 'dummy' checking by filename
   base = os.path.basename(path)
   for foo in ["tar", "tgz", "tbz","rpm"]:
      if foo in base: return True

   return False

def trustPackage(path):
   if not os.path.isfile(path): return

   # Question: should a key really be generated here if there isn't one?
   # see if we need to make the user a key
   #if not os.path.exists(storkusername+".publickey"):
      #makeKey(storkusername)

   command = scriptpath+commandstub+'storkutil.py '+storkutiluserflags+' addfile '+path
   print "debug: about to run ",command
   os.system(command)

def removeTrust(file):
   # see if we need to make the user a key
   if not os.path.exists(storkusername+".publickey"):
      makeKey(storkusername)
      
   command = scriptpath+commandstub+'storkutil.py '+storkutiluserflags+' removefile '+file
   print "debug: about to run ",command
   os.system(command)


def uploadPackage(path):
   metahash = storkpackage.get_package_metadata_hash(path)
   if not sc.url_exists("metadata/stork-repository.cs.arizona.edu_packages_PlanetLab_V3_Testing/"+str(metahash) ):
      # sense it does not already seem to be on the repository, upload it
      sc.upload_file(username, password, path, "package")
   else:
      print "debug: "+path+" exists on server, not uploading"  



def makeKey(user):
   command = scriptpath+commandstub+'storkutil.py --dontask --username='+user+' genpair '+user
   print "debug: about to run: ",command
   os.system(command)
   # If statusframe is defined, then the main window is open and we want to
   # change the syched state. Otherwise, we just want to flag that when the
   # main window opens it should not show as synched.
   global statusframe
   try:
       statusframe
   except NameError:
       global synched
       synched = False
   else:
       statusframe.set_in_synch(False)
   

def getPubKey():
      keyFilePath = storkusername+".publickey"
      print "DEBUG: getPubKey: "+keyFilePath
      if not os.path.isfile(keyFilePath):
          return None
      newFile = open(storkusername+".publickey","r")
      newFile.readline()
      storkpubkey = newFile.readline()+newFile.readline()
      return storkpubkey.replace("\n","").replace("/","_").rstrip("=")

def getGroups():
   storkpubkey = getPubKey()
   grps = []
   grps.append("All")
   groupsfilepath = storkusername+"."+storkpubkey+".groups.pacman"
   if not os.path.isfile(groupsfilepath):
   	print groupsfilepath
   	print "No groups file found. No groups will be added." 
   else:
   	groupFile = open(groupsfilepath)
   	for line in groupFile:
           if line.find("GROUP NAME") != -1:
               groupname = line[16:-6]
               grps.append(groupname)
   # get empty groups that have something set for them in the packages file
   packagesfilepath = storkusername+"."+storkpubkey+".packages.pacman"
   if os.path.isfile(packagesfilepath):
       packagesFile = open(packagesfilepath)
       regex = re.compile(r'CONFIG GROUP="(.+?)"')
       for line in packagesFile:
           matches = regex.search(line)
           if matches and matches.group(1) not in grps:
               grps.append(matches.group(1))
   return grps

def getNodes(group):
   storkpubkey = getPubKey()  
  
   nodeList = []
   groupsfilepath = storkusername+"."+storkpubkey+".groups.pacman"
   if not os.path.isfile(groupsfilepath):
   	return nodeList
   else:
   	groupFile = open(groupsfilepath)
   	
	while(True): #Loops through each line in the groups file
		outerLine = groupFile.readline()
   		if outerLine.find("\""+group+"\"") != -1:
   			while(True): #Loops through every line for this group
				innerLine = groupFile.readline()
				if innerLine.find("GROUP") == -1:
   					if innerLine.find("INCLUDE") != -1:
                                                print "about to append: "+innerLine[18:-7]+" to "+group
   						nodeList.append(innerLine[18:-7])
				else:
					break #Stop looping if we are at the end of the group
			break #Stop looping through the file if we find the group

		if outerLine == "": #Stop looping if we are at the end of the file
			break
   	return nodeList

def getSlices():
   if debug: return ["arizona_client1"]

   slices = sc.getslices(username,password)
   if slices == None:
      return ["Could not fetch slices"]
   else:
      return slices

# This doesn't appear to be used anywhere. trustPackage() is used for this.
def addPackage(package):
   os.system(scriptpath+'/storkutil.py '+storkutiluserflags+' addfile '+package)

def getActions(group):
   #Provides tuples of the form (action, package) for the provided group name. actions will be the returned
   #list of tuples, curAct is the current action that needs to be tuplified, preLen is used to parse the 
   #package name from the line
   storkpubkey = getPubKey()
   actions = []
   curAct = ""
   packagesfilepath = storkusername+"."+storkpubkey+".packages.pacman"
   if not os.path.isfile(packagesfilepath):
   	return actions
   else:
        try:
           actionsFile = open(packagesfilepath, "r")
        except:
           return actions
           	
	while(True): #Loop through each line of the packages file
		outerLine = actionsFile.readline()
   		
   		if group == "All":
   			if outerLine.find("CONFIG&gt") != -1:
   				while(True):
   					innerLine = actionsFile.readline()
   					if innerLine.find("/CONFIG") == -1:
 						if innerLine.find("PACKAGE") != -1:
							if innerLine.find("INSTALL") != -1:
								curAct = "install"
								preLen = 21
							elif innerLine.find("UPDATE") != -1:
								curAct = "update"
								preLen = 20
							elif innerLine.find("REMOVE") != -1:
								curAct = "remove"
								preLen = 20
							curPack = innerLine[preLen:-7]
							actions.append( (curPack, curAct) )
					else:
						break #If we looped through the whole group, stop
				break #If we find the group, stop looping through the file
			if outerLine == "":
				break  						

   		else: #The case where the group IS NOT "All"
			if outerLine.find("CONFIG GROUP=\""+group+"\"") != -1:
				while(True):
					innerLine = actionsFile.readline()
					if innerLine.find("/CONFIG") == -1:
						if innerLine.find("PACKAGE") != -1:
							if innerLine.find("INSTALL") != -1:
								curAct = "install"
								preLen = 21
							elif innerLine.find("UPDATE") != -1:
								curAct = "update"
								preLen = 20
							elif innerLine.find("REMOVE") != -1:
								curAct = "remove"
								preLen = 20
							curPack = innerLine[preLen:-7]
							actions.append( (curPack, curAct) )
					else:
						break #If we looped through the whole group, stop
				break #If we find the group, stop looping through the file
			if outerLine == "":
				break
	actionsFile.close()
	return actions

def createFiles():
	#<Purpose>
	#Creates pacman files, tpfile, config file and list of packages for upload.

	#<Arguments>   
	#None

	#<Exceptions>
	#None

	#<Side Effects>
	#Deletes and rebuilds the aforementioned files

	#<Returns>
	#None

	#Note: This function is currently done by simply invoking storkutil.py with the appropriate command
	#line commands. This can be cleaned up by replacing the "if args=..." statements in storkutil with 
	#functions. If this is done, this section will need to be modified.

    pubkey = storkusername +".publickey"
    prvkey = storkusername +".privatekey"
    if not os.path.isfile(prvkey):
       #file does not exist, we need to create a key for them
           makeKey(storkusername)
 
    storkpubkey = getPubKey()           
	
    #Create pacgroups file. Make sure to add in 'python' when cvsing
    if os.path.isfile(storkusername+"."+storkpubkey+".groups.pacman"):
    	os.remove(storkusername+'.'+storkpubkey+'.groups.pacman')
    for gp in nodes:
    	nodelist = ''
    	for nd in nodes[gp]:
    		nodelist += nd+' '
    	if nodelist != '':
    		os.system(scriptpath+'/storkutil.py '+storkutiluserflags+' pacgroups include '+"'"+gp+"'"+' '+nodelist)
    
    #Create pacpackages file
    if os.path.isfile(storkusername+"."+storkpubkey+".packages.pacman"):	
        os.remove(storkusername+'.'+storkpubkey+'.packages.pacman')
    for gp in actions:
        for act in actions[gp]:
            if(gp == 'All'):
                os.system(scriptpath+'/storkutil.py '+storkutiluserflags+' pacpackages all '+act[1]+' '+act[0])
            else:
                os.system(scriptpath+'/storkutil.py '+storkutiluserflags+' pacpackages group '+"'"+gp+"'"+' '+act[1]+' '+act[0])
		
	#Create a tpfile if one doesn't exist
    if not os.path.isfile(storkusername+"."+getPubKey()+".tpfile"):
        storkutil.makeTPFile(storkusername, False)
        storkutil.signTPFile(storkusername+'.tpfile', storkusername+'.privatekey')
        storkutil.pubKeyEmbed(storkusername+'.tpfile', storkusername+'.publickey')
        os.remove(storkusername+'.tpfile')
    
    # download and alter configuration file
    if not debug and not sc.fetch_configuration(topoptions.get_slice()):
       print "Could not fetch configuration file for "+topoptions.get_slice()+" from the repository."
       print "       This slice will use a copy of the default configuration file."
       # use default conf file if no conf file can be found for this slice
       if not sc.fetch_configuration(topoptions.get_slice(), defaultconf=True):
           print "ERROR: Could not fetch default configuration file."
  
    # change the configuration file
    if not sc.alter_configuration(topoptions.get_slice()+".stork.conf", storkusername, pubkey):
       #if we are about to change some values then
       #warn the user here with a pop-up, and ask them wether to try again, this time overwriting
       #any values

       (susername, pk) = sc.parse_config( topoptions.get_slice()+".stork.conf" )
       if susername == None: susername = "unknown"
       if pk       == None: pk       = "unknown"
       
       # the key is only being compared in name
       if susername == 'default' and pk == 'default.publickey':
           changeidentity = True
       elif storkusername != susername:
           changeidentity = askyesno('Verify', "Slice '"+topoptions.get_slice()+"' \nis currently managed by \nuser '"+susername+"'.\n\nDo you want to change it to your current user '"+storkusername+"'?")
       else:
           changeidentity = askyesno('Verify', "Slice '"+topoptions.get_slice()+"' \ncurrently uses public key '"+pk+"'.\n\nDo you want to change it to your current public key '"+pubkey+"'?") 
       if changeidentity:
          if not sc.alter_configuration(topoptions.get_slice()+".stork.conf", storkusername, pubkey, True):
              print "ERROR: there was an error changing the configuration file"

    # clean up and make any other required changes to the configuration file
    if not sc.clean_configuration(topoptions.get_slice()+".stork.conf"):
        print "ERROR: there was an error cleaning the configuration file"
        
    # upload files
    if not debug:
       showwarning("About to upload new files", "About to upload new files to the repository. This may take a while. During the upload, the GUI will be unresponsive.")
       sc.upload_file(username, password, storkusername+'.'+getPubKey()+'.groups.pacman', "pacman")
       sc.upload_file(username, password, storkusername+'.'+getPubKey()+'.packages.pacman', "pacman")
       sc.upload_file(username, password, storkusername+"."+getPubKey()+".tpfile", "tp")
       sc.upload_file(username, password, pubkey, "pk", topoptions.get_slice())
       sc.upload_file(username, password, topoptions.get_slice()+".stork.conf", "conf", topoptions.get_slice() )

       # upload any packages we need to
       if len(to_upload) > 0:
           short = []
           for foo in to_upload: 
              short.append( os.path.basename(foo) )
           for foo in to_upload:
              uploadPackage(foo)

       # call the auto update page with a list of all the possible nodes to add to this slice
       nodestoadd = []
       for group in groups:
          for node in nodes[group]:
             if node not in nodestoadd:
                nodestoadd.append(node)

       sc.autoSetup(username,password,topoptions.get_slice(),nodestoadd); 


#HARDCODED initial group values
#groups.append("Alpha Group")
#groups.append("Beta Group")

#nodes["Alpha Group"] = ["planetlab-1.cs.princeton.edu", "planetlab-2.cs.princeton.edu", "planetlab-3.cs.princeton.edu"]
#nodes["Beta Group"] = ["planetlab-4.cs.princeton.edu", "planetlab-5.cs.princeton.edu"]
nodes["All"] = []
#actions["Alpha Group"] = [("foo","install"), ("bar","remove")]
#actions["Beta Group"]  = []
actions["All"] = []




class StatusFrame(Frame):
   def __init__(self, parent=None):
      Frame.__init__(self, parent)
      self.parent = parent

      self.goodimage = PhotoImage(file=os.path.join(imagepath, "in-synch-1.gif"))   
      #self.badimage  = PhotoImage(file=os.path.join(imagepath, "out-of-synch-1.gif"))   
      self.upload    = PhotoImage(file=os.path.join(imagepath, "upload-1.gif"))   

      self.helv36 = tkFont.Font ( family="Helvetica",\
        size=14, weight="bold" )

      self.helv10 = tkFont.Font ( family="Helvetica",\
        size=10 )

      self.helv9 = tkFont.Font ( family="Helvetica",\
        size=9, )

      self.linktext = tkFont.Font ( family="Helvetica",\
        size=9, underline=1, weight=tkFont.BOLD)

      self.statusimage = Label(self, image=self.goodimage)

      self.statustext  = Label(self, text="In synch with repository.")
      self.uploadtext  = Label(self, text="Files added or changed.\nSynch with repository.", fg="blue")
      self.uploadimage = Button(self, image=self.upload, command=lambda: self.set_in_synch(True) )

      #self.statusimage.bind("<Button-1>", lambda event: self.set_in_synch(False) )
      self.uploadtext.bind("<Button-1>", lambda event: self.set_in_synch(True))
      
      global synched
      if synched:
          self.statustext.grid(row=1, column=0, sticky=E)
          self.statusimage.grid(row=1, column=1, sticky=E)
      else:
         self.uploadtext.grid(row=0, column=0, sticky=E)
         self.uploadimage.grid(row=0, column=1, sticky=E) 

   def set_in_synch(self, b):
      global synched
      if b:
         # if already synched, let user know no synch necessary
         if synched == True:
            showwarning("No synch necessary", "You are already synched with the repository.")
         else:
            if not topoptions.get_slice():
               showwarning("Select slice", "You must select a slice before synchronizing with the repository.")
               return
            createFiles()
            self.uploadtext.grid_forget()
            self.uploadimage.grid_forget()
            self.statustext.grid(row=0, column=0, sticky=E)
            self.statusimage.grid(row=0, column=1, sticky=E)
      else:
         self.statustext.grid_forget()
         self.statusimage.grid_forget()
         self.uploadtext.grid(row=0, column=0, sticky=E)
         self.uploadimage.grid(row=0, column=1, sticky=E)
      synched = b
     

class TopOptions(Frame):
   def __init__(self, parent=None, root=None):
      Frame.__init__(self, parent)
      self.root = root
      self.helv36 = tkFont.Font ( family="Helvetica",\
        size=14, weight="bold" )

      #self.userimage = PhotoImage(file=os.path.join(imagepath, "user-1.gif"))

      managingslice_label = Label(self, text="is managing") 
      self.username       = Label(self, text="jplichta",font=self.helv36)
      if storkusername != None and storkusername != "":
         self.username.config(text=storkusername)

      self.username.bind("Button-1", lambda event: self.quit() )

      #self.changeframe = Frame(self)
      #self.changetext  = Label(self.changeframe, text="Switch User")
      #self.changeimage = Button(self.changeframe, image=self.userimage, command=self.switchuser)

      self.slicevar       = StringVar()
      self.slicemenu      = OptionMenu(self, self.slicevar, None)
      self.slicemenu["menu"].config(font=self.helv36)
      self.slicemenu["menu"].delete(0, END)
      
      slices = getSlices()
      #if len(slices)>0:
      #   self.slicevar.set(slices[0])
      self.selectsliceprompttext = "[select slice]"
      self.slicevar.set(self.selectsliceprompttext)

      def set_active_slice(self):
         global statusframe
         statusframe.set_in_synch(False)
    
      for foo in slices:
         self.slicemenu["menu"].insert('end','command', label=foo, command=_setit(self.slicevar, foo, set_active_slice)) 
      
      self.username.grid(row=0, column=0, sticky=W)
      managingslice_label.grid(row=0, column=1, sticky=E)
      self.slicemenu.grid(row=0, column=2, sticky=W)
      #self.changetext.grid(row=0, column=0,sticky=W)
      #self.changeimage.grid(row=0, column=1) 
      #self.changeframe.grid(row=1, column=2, sticky=E)

   
   def get_slice(self):
      if self.slicevar.get() == self.selectsliceprompttext:
          return None
      else:
          return self.slicevar.get()

   def switchuser(self):
      #clear all state and reset the application 
      global statusframe
      statusframe.set_in_synch(False)
      #TODO -actually clear the state out
      global switch_user
      switch_user = True
      print "about to switch user, switch_user=",switch_user
      close_window_callback()

class TopBlock(Frame):
   def __init__(self, parent=None):
      Frame.__init__(self, parent)
      self.parent=parent
      self.linktext = tkFont.Font ( family="Helvetica",\
        size=9, underline=1, weight=tkFont.BOLD)
      self.helv10 = tkFont.Font ( family="Helvetica",\
        size=10, weight="bold" )

      self.var = StringVar()

      #addnew   = Label(self, text="Add/Remove group: ")
      self.newfield = Entry(self, textvariable=self.var)
      self.add_group= Button(self, text="Ok", font=self.helv10, command=self.add_group )
      self.cancel   = Button(self, text="Cancel", font=self.helv10, command=self.hide_addfields)
      self.newfield.bind("<Return>", lambda event: self.add_group.invoke() )

      self.addgroup_label = Label(self, text="add group", font=self.linktext, fg="blue", cursor="hand2")
      self.addgroup_label.bind("<Button-1>", lambda event: self.show_addfields() )
      self.addgroup_label.grid(column=0, row=0, sticky=NW) 

   def hide_addfields(self):
      self.addgroup_label.grid(column=0, row=0, sticky=NW)
      self.newfield.grid_forget()
      self.add_group.grid_forget()
      self.cancel.grid_forget()

   def show_addfields(self):
      self.addgroup_label.grid_forget()    
      self.newfield.grid(column=0, row=0, sticky=W)
      self.add_group.grid(column=1, row=0, sticky=W)
      self.cancel.grid(column=2, row=0, sticky=W)
      self.var.set("")
      self.newfield.focus()

   def add_group(self) :
      group = self.newfield.get().strip()
      if len(group) == 0: return
      if re.search(r"[^a-zA-Z0-9_-]", group):
          showwarning("Invalid group name", "Group names can only contain the characters a-z, A-Z, 0-9, underscores, and hyphens.")
          return

      if group not in groups:
         groups.append(group)
         nodes[group] = []
         actions[group] = []
         #create a new group
         newgroup = Group(self.parent, group, self)
         newgroup.grid(pady=3,columnspan=2, sticky=W)
         groupframes[group]=newgroup
         self.set_group(group)
         self.grid_forget()
         self.grid(column=0,pady=10, sticky=NW)
         global statusframe
         statusframe.set_in_synch(False)
         
      self.hide_addfields()

   def remove_group(self):
      if self.var.get() != None and self.var.get() != "":
         # make sure the thing we are trying to move actually exists
         toremove = self.var.get()
         if toremove not in groups: return

         # remove it
         groupframes[toremove].destroy()
         groups.remove(toremove)
         nodes[toremove] = []

         if len(groups) > 0:
            self.set_group( groups[-1] )
         else:
            self.set_group("")
            
         global statusframe
         statusframe.set_in_synch(False)

   def set_group(self, groupname):
      if groupname != None:
         self.var.set(groupname)


class Group(Frame):
    
   nodelist = [] 
   actions  = []
   removenow= (None, None) # the event handler for the node remove button will store its parameters in here
   tempfile = None

   def __init__(self, parent=None, groupname=None, top=None ):
      Frame.__init__(self, parent)
      self.collapsed=1
      self.top = top
      self.group_name = groupname
      self.next_action_row = 0
      self.config(bd=2, relief=RIDGE)
      
      self.ximage = PhotoImage(file=os.path.join(imagepath, "xbutton-1.gif"))   
      #self.addimage=PhotoImage(file=os.path.join(imagepath, "addbutton-1.gif"))

      self.helv36 = tkFont.Font ( family="Helvetica",\
        size=14, weight="bold" )

      self.helv10 = tkFont.Font ( family="Helvetica",\
        size=10 )

      self.helv9 = tkFont.Font ( family="Helvetica",\
        size=9, )

      self.linktext = tkFont.Font ( family="Helvetica",\
        size=9, underline=1, weight=tkFont.BOLD)


      nodelist = nodes[groupname]
      if nodelist != None:
         numnodes = str( len(nodelist) )
      else:
         nodelist = []
         numnodes = "0"

      actionlist = actions[groupname]
      print "actionlist: ",actionlist
      if actionlist == None:
         actionlist = []
      

      if groupname == None:
         groupname = "None"

      group_label_frame = Frame(self)
      inner_group_label_frame = Frame(group_label_frame)
      group_label_frame.grid(row=0, column=0, rowspan=2,  sticky=NW)

     
      remove_group = Button(inner_group_label_frame, image=self.ximage,borderwidth=0, command=self.remove_group)
      self.group= Label(inner_group_label_frame, text=groupname+" ("+numnodes+")", width=30, anchor=W, font=self.helv36)
      if groupname == "All":
         self.group.config(text=groupname+" nodes")

      if groupname != "All":
         remove_group.grid(column=0, row=0, sticky=W)
      
      self.group.grid(column=1, row=0, sticky=W )

      inner_group_label_frame.grid(row=0, column=0, sticky=W)

      self.expandgroup = Label(group_label_frame, text="expand", font=self.linktext, fg="blue", cursor="hand2")
      if groupname != "All":
         self.expandgroup.grid(column=0, row=1, sticky=NW)
         self.expandgroup.bind('<Button-1>', self.expand_group) 

      #self.sbar = Scrollbar(self)
      #self.lbox = Listbox(self, height=5, width=40, relief=SUNKEN)
      self.lbox = Frame(group_label_frame, width=40, relief=GROOVE)

      #construct the box for adding new nodes
      self.addbox = Frame(group_label_frame, bg="#7AFFA4")
      self.add_label    = Label(self.addbox, text="Add:", font=self.helv10, bg="#7AFFA4")
      self.addmethodvar = StringVar()
      self.addmethodvar.set("single node")
      self.optionmenu = OptionMenu(self.addbox, self.addmethodvar, "single node", "CoMon query", "set operation")

      def onchange(name, index, mode):
         if self.addmethodvar.get() == "single node":
	    self.use_singlenode()
         elif self.addmethodvar.get() == "CoMon query":
            self.use_comon()
         elif self.addmethodvar.get() == "set operation":
            self.use_set()

      remember = self.addmethodvar.trace_variable('w', onchange)
      #self.optionmenu["menu"].config(command=onchange)

      self.singlenode_ex = Label(self.addbox, justify=LEFT,width=35,height=2, text="Type in the hostname of a node in \nthe box, ex: planetlab-1.cs.princeton.edu", font=self.helv9, bg="#7AFFA4")
      #self.comon_ex      = Label(self.addbox, justify=LEFT,width=50,height=3, text="Type in a well formed CoMon query to return a set of nodes. \nWARNING: the nodes returned from the query will \nreplace any nodes that are currently in this group.", font=self.helv9, bg="#7AFFA4")
      #self.set_ex        = Label(self.addbox, justify=LEFT,width=25,height=2, text="Union or Intersect this group \nwith another existing group.", font=self.helv9, bg="#7AFFA4")
      self.comon_ex      = Label(self.addbox, justify=LEFT,width=50,height=3, text="Comon support is currently not functional", font=self.helv9, bg="#666666")
      self.set_ex        = Label(self.addbox, justify=LEFT,width=50,height=3, text="Set support is currently not functional", font=self.helv9, bg="#666666")


      self.node_entry    = Entry(self.addbox, width=25 )
      self.node_label    = Label(self.addbox, text="Node:", font=self.helv10, bg="#7AFFA4")

      self.comon_query   = Text(self.addbox, height=4, width=30 , relief=SUNKEN)
      self.comon_label   = Label(self.addbox, text="Query:", font=self.helv10, bg="#7AFFA4")

      self.set_label     = Label(self.addbox, text="Operation:", font=self.helv10, bg="#7AFFA4")
      self.set_option    = StringVar()
      self.set_option.set("intersect")
      self.set_menu      = OptionMenu(self.addbox, self.set_option, "intersect", "union")
      self.set_with      = Label(self.addbox, text="With", font=self.helv10, bg="#7AFFA4")
      self.set_groupvar   = StringVar()
      self.set_grouplist  = OptionMenu(self.addbox, self.set_groupvar, None)
      self.set_grouplist["menu"].delete(0, END)
      self.add_label.grid(row=0, column=0, sticky=NE)
      self.optionmenu.grid(row=0, column=1,sticky=NW)
      self.singlenode_ex.grid(row=1, column=1,sticky=NW)
      self.node_label.grid(row=2, column=0, sticky=NE)
      self.node_entry.grid(row=2, column=1, sticky=NW)

      self.node_buttons = Frame(self.addbox, bg="#7AFFA4")
      self.node_ok        = Button(self.node_buttons, text="Ok", font=self.helv9,  command=self.add_node)
      self.node_cancel    = Button(self.node_buttons, text="Cancel", font=self.helv9,  command=self.hide_addnodes)
      self.node_entry.bind("<Return>", lambda event: self.node_ok.invoke() ) 


      self.node_cancel.grid(row=0, column=0, sticky=NE)
      self.node_ok.grid(row=0, column=1, sticky=NE)
      self.node_buttons.grid(row=3, column=1, sticky=NE)
      
     
      self.addnode_label = Label(group_label_frame, text="add node(s)", font=self.linktext, fg="blue", cursor="hand2")
      self.addnode_label.bind("<Button-1>", lambda event: self.show_addnodes() )
      if groupname != "All":
         self.addnode_label.grid(row=3, column=0, sticky=NW)


      self.actionframe = Frame(self)
      self.action=Label(self.actionframe, text="Actions",width=38,anchor=W, font=self.helv36)
      self.action.grid(column=0, row=0,columnspan=2,  padx=1, sticky=NW)


      self.actionbox = Frame(self.actionframe, width=39, relief=SUNKEN)
      self.actionbox.grid( column=0, row=1, rowspan=1, sticky=NW )

      self.actionframe.grid(column=1, row=0, sticky=NW )
      


      


      for i,foo in enumerate(nodelist):
         n = Label(self.lbox,text=foo, font=self.helv9)
         x = Button(self.lbox, image=self.ximage, borderwidth=0 )
         x['command'] = lambda param=(x,n): self.remove_node(param)

         self.nodelist.append(n)
         x.grid(column=0, row=i, sticky=W, pady=0 ) 
         n.grid(column=1, row=i, sticky=W, pady=0 ) 

      for foo in actionlist:
         n = Label(self.actionbox, text="    "+foo[0]+" ("+foo[1]+")", font=self.helv9, anchor=W)
         x = Button(self.actionbox, image=self.ximage, borderwidth=0)
         x["command"]= lambda param=(n,x,foo): self.remove_action(param)
         self.actions.append(n)
         x.grid(column=0, row=self.next_action_row, padx=0,  sticky=NW)
         n.grid(column=1, row=self.next_action_row, padx=0,  sticky=NW)
         self.next_action_row += 1

      #create the addaction button
      self.add_action_area = Frame(self.actionbox, bg="#7AFFA4", relief=SUNKEN)
      self.add_action_label = Label( self.actionbox, text="add action", font=self.linktext, fg="blue", cursor="hand2")
      self.add_action_label.bind("<Button-1>", lambda event: self.show_actionbuttons() )

      self.action_explenation = Label( self.add_action_area,  text="Either type the name of a package in the text box\nor browse for a package on your filesystem.", font=self.helv9, fg="black", height=2, bg="#7AFFA4")

      self.var = StringVar()
      self.var.set("install")
      self.optionmenu = OptionMenu(self.add_action_area, self.var, "install", "update", "remove")


      self.action_var= StringVar()
      self.add_action= Entry(self.add_action_area,textvariable=self.action_var, width=22, relief=SUNKEN)
      self.add_action.bind("<Return>", lambda event: self.add_action_to_list() )
      self.browse    = Button(self.add_action_area,text="Browse...", font=self.helv10, command=self.browse_for_file)

      self.cancel    = Button(self.add_action_area,text="Cancel", font=self.helv10, command=lambda: self.hide_actionbuttons() )
      self.ok        = Button(self.add_action_area,text="Ok", font=self.helv10,command=lambda: self.add_action_to_list() )
      
      self.action_explenation.grid(column=0, row=0,columnspan=2,  sticky=NW)
      self.add_action.grid(column=0, row=2, sticky=NW)
      self.browse.grid(column=1,  row=2, sticky=NW)
      self.optionmenu.grid(column=0, row=3, sticky=NE)
      self.cancel.grid(column=0, row=4, sticky=NE)
      self.ok.grid(column=1, row=4, sticky=NW)
      

      self.add_action_label.grid(column=0, columnspan=2, sticky=W)

   def browse_for_file(self):
      filename = tkFileDialog.askopenfilename()
      if not filename: return
      if not isPackage(filename):
            showerror("Package not understood", "The package must be an rpm or a tar.")
            self.action_var.set("")
            return

      print "filename=",filename
      if (self.var.get() == "update" or self.var.get() == "install") and os.path.isfile(filename):
         self.tempfile = filename
         self.action_var.set( os.path.basename( filename ) )
      


   def show_addnodes(self):
      self.addnode_label.grid_forget()
      self.addbox.grid(row=4,column=0, sticky=NW)
      self.addmethodvar.set("single node")
      self.node_entry.delete(0, len(self.node_entry.get()))
      #self.use_singlenode()

   def hide_addnodes(self):
      self.addbox.grid_forget()
      self.addnode_label.grid(row=3,column=0, sticky=NW)

   def use_singlenode(self):
      self.node_buttons.grid_forget()
      self.comon_ex.grid_forget()
      self.comon_label.grid_forget()
      self.comon_query.grid_forget()

      self.set_ex.grid_forget()
      self.set_label.grid_forget()
      self.set_menu.grid_forget()
      self.set_with.grid_forget()
      self.set_grouplist.grid_forget()     

      self.singlenode_ex.grid(row=1, column=1,sticky=NW)
      self.node_label.grid(row=2, column=0, sticky=NE)
      self.node_entry.grid(row=2, column=1, sticky=NW)
      self.node_cancel.grid(row=3, column=0, sticky=NE)
      self.node_ok.grid(row=3, column=1, sticky=NE)
      self.node_buttons.grid(row=3, column=1, sticky=NE)
      self.node_entry.focus() 
  
   def use_comon(self):
      self.node_buttons.grid_forget()
      self.singlenode_ex.grid_forget()
      self.node_label.grid_forget()
      self.node_entry.grid_forget()

      self.set_ex.grid_forget()
      self.set_label.grid_forget()
      self.set_menu.grid_forget()
      self.set_with.grid_forget()
      self.set_grouplist.grid_forget()     

      self.comon_ex.grid(row=1, column=1, sticky=NW)
      self.comon_label.grid(row=2, column=0, sticky=NE)
      self.comon_query.grid(row=2, column=1, sticky=NW)
      self.node_buttons.grid(row=3, column=1, sticky=NE)
      self.comon_query.focus()

   def use_set(self):
      self.node_buttons.grid_forget()
      self.singlenode_ex.grid_forget()
      self.node_label.grid_forget()
      self.node_entry.grid_forget()

      self.comon_ex.grid_forget()
      self.comon_label.grid_forget()
      self.comon_query.grid_forget()

      self.set_ex.grid(row=1, column=1,  sticky=NW)
      self.set_label.grid(row=2, column=0, sticky=NE)
      self.set_menu.grid(row=2, column=1,sticky=NW)
      self.set_with.grid(row=3, column=0, sticky=NE)
      self.set_grouplist.grid(row=3, column=1, sticky=NW)
      self.node_buttons.grid(row=4, column=1, sticky=NE)

      try:
         self.set_grouplist["menu"].delete(0,END)
      except: pass

      def nothing(junk): pass

      for foo in groups:
         if foo == 'All': continue
         if foo!=self.group_name:
            self.set_grouplist["menu"].insert('end','command', label=foo, command=_setit(self.set_groupvar, foo, nothing)) 
            self.set_groupvar.set(foo)
      
   
   # this function will add a node to the current group,
   # how that node or nodes is/are added depends on the
   # method the user choose, eg: single node, comon, set op
   def add_node(self):
      method = self.addmethodvar.get()

      if method == "single node":
         node = self.node_entry.get().strip()
         if len(node) == 0: return
         # TODO separately check valid for hostname, IPv4, or IPv6
         if re.search(r"[^a-zA-Z0-9:.-]", node):
            showwarning("Invalid group name", "Node names can only contain the characters a-z, A-Z, 0-9, periods, hyphens, and colons.")
            return
         print "about to add single node: ",node
         if node != None and node != "" and node not in nodes[self.group_name]: 
            # add this node to the group
            i = len(nodes[self.group_name])
            nodes[self.group_name].append(node)

            n = Label(self.lbox,text=node, font=self.helv9)
            x = Button(self.lbox, image=self.ximage, borderwidth=0 )
            x['command'] = lambda param=(x,n): self.remove_node(param)
            
            self.nodelist.append(n)
            x.grid(column=0, row=i, sticky=W, pady=0 ) 
            n.grid(column=1, row=i, sticky=W, pady=0 ) 
            #update label
            self.group.config(text=self.group_name+" ("+str(len(nodes[self.group_name]))+")" )
            global statusframe
            statusframe.set_in_synch(False)

         pass #TODO stub
      elif method == "CoMon query":
         pass #TODO stub
      elif method == "set operation":
         pass #TODO stub

      self.hide_addnodes(); 


   def hide_actionbuttons(self):
      self.add_action_area.grid_forget()
      self.add_action_label.grid(column=0)

       
   def show_actionbuttons(self):
      self.add_action_label.grid_forget()
      self.add_action_area.grid(column=0, columnspan=2 )
      self.add_action.focus()
      self.add_action.delete(0, len(self.add_action.get()))


   def add_action_to_list(self):
       #param is (package, type)
       param = ( self.add_action.get().strip(), self.var.get() )
       if len(param[0]) == 0:
          return
       for existingparam in actions[self.group_name]:
          if param[0] == existingparam[0]:
             showwarning("Action already exists", "An action already exists for this package. To change the action for this package, remove the current action and then add the new one.")
             return
       if re.search(r"[^a-zA-Z0-9._-]", param[0]):
          showwarning("Invalid package name", "Package names can only contain the characters a-z, A-Z, 0-9, periods, underscores, and hyphens.")
          return
      
       print "addactin param=",param
       print "actions[self.group_name]: ",actions[self.group_name]
       print "going to add new action to row=",self.next_action_row

       n = Label(self.actionbox, text="    "+param[0]+" ("+param[1]+")", font=self.helv9)
       x = Button(self.actionbox, image=self.ximage, borderwidth=0)
       x["command"]= lambda param=(n,x,param): self.remove_action(param)
       self.actions.append(n)
       x.grid(column=0, row=self.next_action_row, sticky=NW)
       n.grid(column=1, row=self.next_action_row, sticky=NW)
       self.next_action_row += 1

       actions[self.group_name].append( param )
       self.hide_actionbuttons()
       global statusframe
       statusframe.set_in_synch(False)
    
       # see if we have to add this to the trusted packages file (that is,
       # if the user just selected a package on their file system
       if self.tempfile != None:
         global to_upload
         if self.tempfile not in to_upload:
            trustPackage(self.tempfile)
            to_upload.append(self.tempfile) 

       self.tempfile = None


       

   def remove_action(self, param):
      self.actions.remove(param[0])
      param[0].destroy()
      param[1].destroy()
      #TODO Error, the tuple is not being removed from the action list correctly
      print "remove_action param=", param

      actiontuple = param[2]
      for foo in actions[self.group_name]:
         if foo[0] == actiontuple[0] and foo[1] == actiontuple[1]:
            print "removing: ",foo
            actions[self.group_name].remove(foo)
            global statusframe
            statusframe.set_in_synch(False)

   def remove_node(self, param):
      node = param[1]["text"]
      if node in nodes[self.group_name]:
         nodes[self.group_name].remove(node)
      param[0].destroy()
      param[1].grid_forget()
      param[1].destroy()
      self.group.config(text=self.group_name+" ("+str(len(nodes[self.group_name]))+")" )
      global statusframe
      statusframe.set_in_synch(False)
      
   def collapse_group(self, event):
      #do everything needed to make most items "hidden"
      if self.collapsed: return

      self.lbox.grid_forget()
      
      self.collapsed = 1       
      self.expandgroup.bind('<Button-1>', self.expand_group)
      self.expandgroup.config(text="expand") 
  

   def expand_group(self, event):
      #do everything needed to make things visible again
      if not self.collapsed: return

      self.lbox.grid( column=0, row=2, sticky='nw', pady=0 ) 

      self.collapsed = 0
      self.expandgroup.bind('<Button-1>', self.collapse_group )
      self.expandgroup.config(text="collapse")

   def remove_group(self):
      #TODO put hook into storkutil to remove this group
      groups.remove(self.group_name)
      nodes[self.group_name] = []
      self.destroy()
      global statusframe
      statusframe.set_in_synch(False)

def authenticate(username, password):
   #TODO finish authenticate stub by making a call to the repository via curl
   return sc.login(username, password)
 
authenticated = False
def makeloginwindow():
   login = Tk()
   login.title('Stork Slice Manager')
   login.width=1100
   login.height=800
   helv10 = tkFont.Font ( family="Helvetica",\
        size=10, weight="bold" )
   
   ex_label       = Label(login,width=60, height=3, justify=LEFT, text="Please enter your Planetlab username/password. \nThis information will only be transmitted over a secure connection \nand is needed to identify the slices you have access to")

   username_label = Label(login,width=20,text="Planetlab Username:")
   password_label = Label(login,width=20,text="Planetlab Password:")
   storkusername_l = Label(login,width=20,text="Stork Username:")

   username_field = Entry(login)
   password_field = Entry(login,show="*")
   storkusername_e= Entry(login) #TODO try to search the current directory to see if we can fill this field out
   	

   def trylogin():
      global storkusername
      global username
      global password
      username = username_field.get().strip()
      password = password_field.get()
      storkusername = storkusername_e.get().strip()
      if len(username) == 0:
         ex_label.config(text="Please enter your PlanetLab username.", fg="red")
         return
      if len(password) == 0:
         ex_label.config(text="Please enter your PlanetLab password.", fg="red")
         return
      if len(storkusername) == 0:
         ex_label.config(text="Please enter your Stork username.", fg="red")
         return         
      if re.search(r"[^a-zA-Z0-9_-]", storkusername):
         ex_label.config(text="Stork usernames can only contain the characters \na-z, A-Z, 0-9, underscores, and hyphens.", fg="red")
         return
     
      if authenticate(username_field.get(), password_field.get() ):
         authenticated=True
         # fetch any possible pacman files (and tpfiles?) for the current storkustname
         pubkey = getPubKey()
         if pubkey == None:
            #ask them if they want a new key
            result = askyesno("New User","Key for user '"+storkusername+"' not found. Create a new key for this user?")
            if result == True:
            	makeKey(storkusername)
            else:
            	print "No user key present. Please create a user key or use a recognized username."
            	return
            pubkey = getPubKey()
            if pubkey == None:
               print "Error: could not create/read public key for: "+storkusername
               return

         # user is now logged in and has a valid key
         global storkutiluserflags
         storkutiluserflags = '--username='+storkusername+' --publickey='+storkusername+'.publickey --privatekey='+storkusername+'.privatekey'

         sc.get_file("user-upload/pacman/"+storkusername+"."+pubkey+".packages.pacman", storkusername+"."+pubkey+".packages.pacman")
         sc.get_file("user-upload/pacman/"+storkusername+"."+pubkey+".groups.pacman", storkusername+"."+pubkey+".groups.pacman")
         sc.get_file("user-upload/tpfiles/"+storkusername+"."+pubkey+".tpfile", storkusername+"."+pubkey+".tpfile")

         #initialize the nodes/groups/packages
         global groups
         global nodes
         global actions
         groups = getGroups()
         for group in groups:
            nodes[group] = getNodes(group)
            actions[group] = getActions(group)

         login.destroy()
      else:
         ex_label.config(text="Invalid username/password. Please try again", fg="red")

   button_frame   = Frame(login)
   ok_button      = Button(button_frame,text="Ok", command=trylogin)
   cancel_button  = Button(button_frame,text="Cancel",command=lambda: sys.exit(0) )
   cancel_button.grid(row=0, column=0, sticky=E)
   ok_button.grid(row=0, column=1, sticky=E)

   ex_label.grid(row=0, column=0, columnspan=2, sticky=NW)
   username_label.grid(row=1, column=0, sticky=W)
   username_field.grid(row=1, column=1, sticky=W)
   password_label.grid(row=2, column=0, sticky=W)
   password_field.grid(row=2, column=1, sticky=W)
   storkusername_l.grid(row=3, column=0,sticky=W)
   storkusername_e.grid(row=3, column=1,sticky=W)
   button_frame.grid(row=4, column=0, columnspan=2, sticky=E)

   username_field.bind("<Return>", lambda event: password_field.focus() )
   password_field.bind("<Return>", lambda event: storkusername_e.focus() )
   storkusername_e.bind("<Return>",lambda event: ok_button.invoke() )
   username_field.focus()

   login.geometry("+%d+%d" % (300, 300))

   print "about to check for update"
   check_for_update()

   login.mainloop() 

def close_window_callback():
   global synched
   if synched or askokcancel("Exit without synching?", "You have changes that are not synched with the repository. These changes will be lost if you exit. \n\nClick OK to exit without synching.", default=CANCEL):
      global root
      root.destroy()

def check_for_update():
   global checkedforupdate
   if not checkedforupdate:
      uptodate, version, component = sc.is_latest_version(guiversion)

      if not uptodate and version != "unknown":
         showstring = "The "+str(component)+" module is currently at version \n"
         if component == "storkslicemanager":
	    showstring = showstring + guiversion
         elif component == "storkcurlfuncs": 
            showstring = showstring + sc.scversion

         showstring = showstring + "\nand can be autoupdated to\n"+version+"\n"
         showstring = showstring + "Would you like to update?\n"

         if askyesno("Out of date", showstring):
            sc.update_gui(scriptpath)

      checkedforupdate = True



def main():
   #if we have not checked for an update yet, do so
   if not os.path.isfile( os.path.expanduser("~/.storkmanager.conf") ):
      try:
         f = open( os.path.expanduser("~/.storkmanager.conf"), "w")
         f.write("tarpackinfo = /tmp/tarinfo\n")
         f.close()
      except:
         pass

   args = arizonaconfig.init_options('storkslicemanager.py', usage="", configfile_optvar='managerconf', version='2.0')

   if not debug:
      makeloginwindow()
     
   global switch_user
   switch_user = False

   global root
   root = Tk()
   root.title('Stork Slice Manager')
   root.width=800
   root.height=600
   root.grid_propagate(True)


   #create main scrollable canvas
   cnv = Canvas(root, width=root.width-20, height=600)
   cnv.grid(row=0, column=0, sticky='nswe')
   vScroll = Scrollbar(root, orient=VERTICAL, command=cnv.yview)
   vScroll.grid(row=0, column=1, sticky='ns')
   cnv.configure(yscrollcommand=vScroll.set)
   #make a frame to put in the canvas
   frm = Frame(cnv)
   #put the frame in the canvas's scrollable area
   cnv.create_window(0,0, window=frm, anchor='nw')


   top   = TopBlock(frm)

   global topoptions
   topoptions = TopOptions(frm,root)
   global statusframe
   statusframe= StatusFrame(frm)
   #groupframes.append(group)
   #group.config(bd=2, relief=GROOVE)
   

   # place it somewhere on the screen that makes sense
   #frm.geometry("%dx%d" % (300, 500) )
   root.geometry("%dx%d+%d+%d" % (800, 600, 50, 50))
   
   # setup some event handlers

   def somethinghappened(event):
      frm.update_idletasks()
      cnv.configure(scrollregion=(0, 0, frm.winfo_width(), frm.winfo_height()))

   def scrollDown(event):
      cnv.yview_scroll(2, 'units')
   def scrollUp(event):
      cnv.yview_scroll(-2, 'units')

   root.bind('<Button-4>', scrollUp)
   root.bind('<Button-5>', scrollDown)

   frm.bind("<Configure>", somethinghappened)

   frm.grid_propagate(True)
   frm.update_idletasks()
   cnv.configure(scrollregion=(0, 0, 800, frm.winfo_height()))

   
   topoptions.grid(pady=10,row=0, column=0, sticky=NW)
   statusframe.grid(pady=10,row=0,column=1, sticky=NW)
  
   group = Group(frm, "All", top)
   group.grid(pady=3, columnspan=2, sticky=NW)
   groupframes["All"] = group

   for foo in groups:
      if foo == "All": continue
      group = Group(frm, foo, top)
      group.config(relief=GROOVE)
      group.grid(pady=3,columnspan=2, sticky=NW) 
      groupframes[foo] = group

   groups.append("All")

   if len(groups) > 0:
      top.set_group( groups[-1] )  
 
   top.grid(pady=20, sticky=NW)
   
   # assign a callback function for when the user closes the window        
   root.protocol("WM_DELETE_WINDOW", close_window_callback)

   # setup the menu bar
   menubar = Menu(root)
   # File menu
   filemenu = Menu(menubar, tearoff=0)
   filemenu.add_command(label="Exit", command=close_window_callback)
   menubar.add_cascade(label="File", menu=filemenu)
   # User menu
   usermenu = Menu(menubar, tearoff=0)
   usermenu.add_command(label="Switch user", command=topoptions.switchuser)
   menubar.add_cascade(label="User", menu=usermenu)
   # Repository menu
   repositorymenu = Menu(menubar, tearoff=0)
   repositorymenu.add_command(label="Synch with repository", command=lambda: statusframe.set_in_synch(True))
   menubar.add_cascade(label="Repository", menu=repositorymenu)
   # Help menu
   helpmenu = Menu(menubar, tearoff=0)
   helpmenu.add_command(label="Stork website", command=lambda: webbrowser.open("http://www.cs.arizona.edu/stork/"))
   helpmenu.add_command(label="Stork forum", command=lambda: webbrowser.open("http://cgi.cs.arizona.edu/projects/stork/forum/"))
   menubar.add_cascade(label="Help", menu=helpmenu)
   # display the menu
   root.config(menu=menubar)

   root.mainloop()



if __name__ == "__main__":

   while True:  
      main()
      print "about to exit or restart, switch_user=",switch_user
      if not switch_user:
         break 
